Package com.oracle.truffle.api.instrument.impl

## Class SimpleEventReceiver

- java.lang.Object
- - com.oracle.truffle.api.instrument.impl.SimpleEventReceiver

All Implemented Interfaces:
  `TruffleEventReceiver`

    public abstract class SimpleEventReceiver
    extends java.lang.Object
    implements TruffleEventReceiver

An abstract receiver for AST execution events that ignores return values and supports handling all events by overriding only two methods:

- `enter(Node, VirtualFrame)`, and
- `returnAny(Node, VirtualFrame)`.

### Constructor Summary

Constructors
`SimpleEventReceiver()`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `enter​(Node node, VirtualFrame frame)` Receive notification that an AST node's execute method is about to be called.
`void` `returnAny​(Node node, VirtualFrame frame)` Receive notification that one of an AST Node's execute methods has just returned by any means: with or without a return value (ignored) or via exception (ignored).
`void` `returnExceptional​(Node node, VirtualFrame frame, java.lang.Exception e)` Receive notification that an AST Node's execute method has just thrown an exception.
`void` `returnValue​(Node node, VirtualFrame frame, java.lang.Object result)` Receive notification that an AST Node'sexecute method has just returned a value (boxed if primitive).
`void` `returnVoid​(Node node, VirtualFrame frame)` Receive notification that an AST Node's `void`-valued execute method has just returned.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### SimpleEventReceiver

    public SimpleEventReceiver()

### Method Detail

#### enter

    public void enter​(Node node,
                      VirtualFrame frame)

Description copied from interface: `TruffleEventReceiver`
Receive notification that an AST node's execute method is about to be called.

Specified by:
  `enter` in interface `TruffleEventReceiver`

#### returnAny

    public void returnAny​(Node node,
                          VirtualFrame frame)

Receive notification that one of an AST Node's execute methods has just returned by any means: with or without a return value (ignored) or via exception (ignored).

Parameters:
  `node` -
  `frame` -

#### returnVoid

    public final void returnVoid​(Node node,
                                 VirtualFrame frame)

Description copied from interface: `TruffleEventReceiver`
Receive notification that an AST Node's `void`-valued execute method has just returned.

Specified by:
  `returnVoid` in interface `TruffleEventReceiver`

#### returnValue

    public final void returnValue​(Node node,
                                  VirtualFrame frame,
                                  java.lang.Object result)

Description copied from interface: `TruffleEventReceiver`
Receive notification that an AST Node'sexecute method has just returned a value (boxed if primitive).

Specified by:
  `returnValue` in interface `TruffleEventReceiver`

#### returnExceptional

    public final void returnExceptional​(Node node,
                                        VirtualFrame frame,
                                        java.lang.Exception e)

Description copied from interface: `TruffleEventReceiver`
Receive notification that an AST Node's execute method has just thrown an exception.

Specified by:
  `returnExceptional` in interface `TruffleEventReceiver`